package re.jimmitry.apps974.furious;
import re.jimmitry.apps974.furious.*;
import re.jimmitry.apps974.fursys.*;
import re.jimmitry.apps974.wsfurious.*;
import re.jimmitry.apps974.wsfurious.xsd.*;
import java.util.GregorianCalendar;
public class SQL_BOOL {
public static FurSYS_DATA AND(FurSYS_DATA BOOL1, FurSYS_DATA BOOL2) {
  if (BOOL1.isNull || BOOL2.isNull) {
    return new FurSYS_DATA(true, "(null)");
  } else {
    if (BOOL1.DATA.equals("True") && BOOL2.DATA.equals("True")) return new FurSYS_DATA(false, "True");
    else return new FurSYS_DATA(false, "False");
  }
}
public static FurSYS_DATA ENDSWITH(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  try {
    if (DATA1.isNull || DATA2.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      if (DATA1.DATA.endsWith(DATA2.DATA)) return new FurSYS_DATA(false, "True");
      else return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA EQUAL(FurSYS_DATA str1, FurSYS_DATA str2) {
  if (str1.isNull && str2.isNull) {
    return new FurSYS_DATA(false, "True");
  } else if (str1.isNull) {
    return new FurSYS_DATA(false, "False");
  } else if (str2.isNull) {
    return new FurSYS_DATA(false, "False");
  } else {
    if (str1.DATA.equals(str2.DATA)) return new FurSYS_DATA(false, "True");
    else return new FurSYS_DATA(false, "False");
  }
}
public static FurSYS_DATA GREATER(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  try {
    if (DATA1.isNull || DATA2.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      if (Double.parseDouble(DATA1.DATA)>Double.parseDouble(DATA2.DATA)) return new FurSYS_DATA(false, "True");
      else return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA GREATERE(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  try {
    if (DATA1.isNull || DATA2.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      if (Double.parseDouble(DATA1.DATA)>=Double.parseDouble(DATA2.DATA)) return new FurSYS_DATA(false, "True");
      else return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA ISBOOL(FurSYS_DATA data, FurSYS_DATA bool1, FurSYS_DATA bool2) {
  return OR(EQUAL(data, bool1), EQUAL(data, bool2));
}
public static FurSYS_DATA ISCHAR(FurSYS_DATA DATA, FurSYS_DATA SIZE) {
  try {
    if (DATA.isNull || SIZE.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      if (DATA.DATA.length()!=Integer.parseInt(SIZE.DATA)) {
        return new FurSYS_DATA(false, "False");
      }
      else return new FurSYS_DATA(false, "True");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA ISDATE(FurSYS_DATA DATA) { //Exemple: '1980-06-18'
  try {
    if (DATA.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      boolean b = true;
      try
      {
        GregorianCalendar d = new GregorianCalendar();
        d.set(GregorianCalendar.YEAR, Integer.parseInt(Fur_Atome.getAtome(DATA.DATA, "1", "-")));
        d.set(GregorianCalendar.MONTH, Integer.parseInt(Fur_Atome.getAtome(DATA.DATA, "2", "-"))-1);
        d.set(GregorianCalendar.DAY_OF_MONTH, Integer.parseInt(Fur_Atome.getAtome(DATA.DATA, "3", "-")));
        if (!(d.get(GregorianCalendar.DAY_OF_MONTH)==Integer.parseInt(Fur_Atome.getAtome(DATA.DATA, "3", "-")) && d.get(GregorianCalendar.MONTH)==(Integer.parseInt(Fur_Atome.getAtome(DATA.DATA, "2", "-"))-1) && d.get(GregorianCalendar.YEAR)==Integer.parseInt(Fur_Atome.getAtome(DATA.DATA, "1", "-")))) b = false;
      }
      catch (Exception e)
      {
        b = false;
      }
      if (b) return new FurSYS_DATA(false, "True");
      return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA ISDECIMAL(FurSYS_DATA ch, FurSYS_DATA E, FurSYS_DATA F)
{
  try {
    if (ch.isNull || E.isNull || F.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      boolean b = true;
      String gauche = "", droite = "", str=ch.DATA.trim();
      if (str.charAt(0) == '-') str = str.substring(1);
      str = str.replace(",", ".");
      if (Fur_Atome.getSizeAtomeList(str, ".").equals("1")) str = str + ".";
      if (!Fur_Atome.getSizeAtomeList(str, ".").equals("2")) b = false;
      else
      {
        gauche = Fur_Atome.getAtome(str, "1", ".");
        droite = Fur_Atome.getAtome(str, "2", ".");
        if ((!(ISNUMBER(new FurSYS_DATA(false, gauche)).DATA.equals("True"))) || (!(ISNUMBER(new FurSYS_DATA(false, droite)).DATA.equals("True"))))
        {
          b = false;
        }
        else
        {
          if (gauche.length() > Integer.parseInt(E.DATA) || droite.length() > Integer.parseInt(F.DATA)) b = false;
          else b = true;
        }
      }
      if (b) return new FurSYS_DATA(false, "True");
      else return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA ISENUM(FurSYS_DATA data, FurSYS_DATA ENUM, FurSYS_DATA SEPARATOR)
{
  try {
    if (data.isNull || ENUM.isNull || SEPARATOR.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      boolean b = false;
      for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(ENUM.DATA, SEPARATOR.DATA));i++) {
        if (Fur_Atome.getAtome(ENUM.DATA, ""+i, SEPARATOR.DATA).equals(data.DATA)) {
          b=true;
          break;
        }
      }
      if (b) return new FurSYS_DATA(false, "True");
      else return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA ISHOUR(FurSYS_DATA DATA) { // Exemple: 12:35:56
  try {
    if (DATA.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      boolean b = true;
      if (Fur_Atome.getSizeAtomeList(DATA.DATA,":").equals("3"))
      {
        String h = Fur_Atome.getAtome(DATA.DATA,"1",":"), m = Fur_Atome.getAtome(DATA.DATA,"2",":"), s = Fur_Atome.getAtome(DATA.DATA,"3",":");
        try
        {
          if (Integer.parseInt(h)<=23 && Integer.parseInt(m)<=59 && Integer.parseInt(s)<=59)
            b = true;
          else b = false;
        }
        catch (Exception e)
        {
          b = false;
        }
      }
      else
      {
        b = false;
      }
      if (b) return new FurSYS_DATA(false, "True");
      return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA ISINTEGER(FurSYS_DATA data, FurSYS_DATA size)
{
  return ISDECIMAL(data, size, new FurSYS_DATA(false, "0"));
}
public static FurSYS_DATA ISNULL(FurSYS_DATA str) {
  if (str.isNull) {
    return new FurSYS_DATA(false, "True");
  } else {
    return new FurSYS_DATA(false, "False");
  }
}
public static FurSYS_DATA ISNUMBER(FurSYS_DATA DATA) {
  try {
    if (DATA.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      boolean b = true;
      for(int i = 0;i<DATA.DATA.length();i++)
      {
        if (DATA.DATA.charAt(i) < 48 || DATA.DATA.charAt(i) > 57) b = false;
      }
      if (b) return new FurSYS_DATA(false, "True");
      return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA ISTIMESTAMP(FurSYS_DATA DATA) {// Exemple: 2009-06-18 12:00:00
  try {
    if (DATA.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      boolean b = true;
      if (Fur_Atome.getSizeAtomeList(DATA.DATA," ").equals("2"))
      {
        String d = Fur_Atome.getAtome(DATA.DATA,"1"," ");
        String h = Fur_Atome.getAtome(DATA.DATA,"2"," ");
        if (!ISDATE(new FurSYS_DATA(false, d)).DATA.equals("True")) b=false;
        else {
          if (!ISHOUR(new FurSYS_DATA(false, h)).DATA.equals("True")) b=false;
        }
      } else {
        b=false;
      }
      if (b) return new FurSYS_DATA(false, "True");
      return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA ISVARCHAR(FurSYS_DATA DATA, FurSYS_DATA SIZE) {
  try {
    if (DATA.isNull || SIZE.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      if (DATA.DATA.length()>Integer.parseInt(SIZE.DATA)) {
        return new FurSYS_DATA(false, "False");
      }
      else return new FurSYS_DATA(false, "True");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA LESS(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  try {
    if (DATA1.isNull || DATA2.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      if (Double.parseDouble(DATA1.DATA)<Double.parseDouble(DATA2.DATA)) return new FurSYS_DATA(false, "True");
      else return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA LESSE(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  try {
    if (DATA1.isNull || DATA2.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      if (Double.parseDouble(DATA1.DATA)<=Double.parseDouble(DATA2.DATA)) return new FurSYS_DATA(false, "True");
      else return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA LIKE(FurSYS_DATA str1, FurSYS_DATA str2) {
  if (str1.isNull || str2.isNull) {
    return new FurSYS_DATA(true, "(null)");
  } else {
    if (str1.DATA.matches(str2.DATA))
      return new FurSYS_DATA(false, "True");
    else return new FurSYS_DATA(false, "False");
  }
}
public static FurSYS_DATA NOT(FurSYS_DATA BOOL) {
  if (BOOL.isNull) {
    return new FurSYS_DATA(true, "(null)");
  } else {
    if (BOOL.DATA.equals("False")) return new FurSYS_DATA(false, "True");
    else return new FurSYS_DATA(false, "False");
  }
}
public static FurSYS_DATA NUMEQUAL(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  try {
    if (DATA1.isNull || DATA2.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      if (Double.parseDouble(DATA1.DATA)==Double.parseDouble(DATA2.DATA)) return new FurSYS_DATA(false, "True");
      else return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
public static FurSYS_DATA OR(FurSYS_DATA BOOL1, FurSYS_DATA BOOL2) {
  if (BOOL1.isNull && BOOL2.isNull) {
    return new FurSYS_DATA(true, "(null)");
  } else {
    if (BOOL1.DATA.equals("True") || BOOL2.DATA.equals("True")) return new FurSYS_DATA(false, "True");
    else return new FurSYS_DATA(false, "False");
  }
}
public static FurSYS_DATA STARTSWITH(FurSYS_DATA DATA1, FurSYS_DATA DATA2) {
  try {
    if (DATA1.isNull || DATA2.isNull) {
      return new FurSYS_DATA(true, "(null)");
    } else {
      if (DATA1.DATA.startsWith(DATA2.DATA)) return new FurSYS_DATA(false, "True");
      else return new FurSYS_DATA(false, "False");
    }
  } catch (Exception e) {
    return new FurSYS_DATA(true, "(null)");
  }
}
}
